org.apache.commons.math3.ode

## Class FirstOrderConverter

- java.lang.Object
- - org.apache.commons.math3.ode.FirstOrderConverter

- All Implemented Interfaces:
    FirstOrderDifferentialEquations

      public class FirstOrderConverter
      extends java.lang.Object
      implements FirstOrderDifferentialEquations

  This class converts second order differential equations to first order ones.

  This class is a wrapper around a `SecondOrderDifferentialEquations` which allow to use a `FirstOrderIntegrator` to integrate it.

  The transformation is done by changing the n dimension state vector to a 2n dimension vector, where the first n components are the initial state variables and the n last components are their first time derivative. The first time derivative of this state vector then really contains both the first and second time derivative of the initial state vector, which can be handled by the underlying second order equations set.

  One should be aware that the data is duplicated during the transformation process and that for each call to `computeDerivatives`, this wrapper does copy 4n scalars : 2n before the call to `computeSecondDerivatives` in order to dispatch the y state vector into z and zDot, and 2n after the call to gather zDot and zDDot into yDot. Since the underlying problem by itself perhaps also needs to copy data and dispatch the arrays into domain objects, this has an impact on both memory and CPU usage. The only way to avoid this duplication is to perform the transformation at the problem level, i.e. to implement the problem as a first order one and then avoid using this class.

  Since:
    1.2
  Version:
    $Id: FirstOrderConverter.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    `FirstOrderIntegrator`, `FirstOrderDifferentialEquations`, `SecondOrderDifferentialEquations`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private int` | `dimension` second order problem dimension.
    `private SecondOrderDifferentialEquations` | `equations` Underlying second order equations set.
    `private double[]` | `z` state vector.
    `private double[]` | `zDDot` second time derivative of the state vector.
    `private double[]` | `zDot` first time derivative of the state vector.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FirstOrderConverter(SecondOrderDifferentialEquations equations)` Simple constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `computeDerivatives(double t, double[] y, double[] yDot)` Get the current time derivative of the state vector.
    `int` | `getDimension()` Get the dimension of the problem.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### equations

          private final SecondOrderDifferentialEquations equations

      Underlying second order equations set.

    - #### dimension

          private final int dimension

      second order problem dimension.

    - #### z

          private final double[] z

      state vector.

    - #### zDot

          private final double[] zDot

      first time derivative of the state vector.

    - #### zDDot

          private final double[] zDDot

      second time derivative of the state vector.

  - ### Constructor Detail

    - #### FirstOrderConverter

          public FirstOrderConverter(SecondOrderDifferentialEquations equations)

      Simple constructor. Build a converter around a second order equations set.
      Parameters:
        `equations` - second order equations set to convert

  - ### Method Detail

    - #### getDimension

          public int getDimension()

      Get the dimension of the problem.

      The dimension of the first order problem is twice the dimension of the underlying second order problem.

      Specified by:
        `getDimension` in interface `FirstOrderDifferentialEquations`
      Returns:
        dimension of the problem

    - #### computeDerivatives

          public void computeDerivatives(double t,
                                double[] y,
                                double[] yDot)

      Get the current time derivative of the state vector.
      Specified by:
        `computeDerivatives` in interface `FirstOrderDifferentialEquations`
      Parameters:
        `t` - current value of the independent time variable
        `y` - array containing the current value of the state vector
        `yDot` - placeholder array where to put the time derivative of the state vector

Copyright (c) 2003-2013 Apache Software Foundation